; Use Console Assemble and Link to create
;
; After done testing delete Combos.dat and C.ndx
; Change software to only use Node file and Node routines
;
; The creating file process takes the longest to execute, insert logic to bypass if already created
;
; This test app takes about 20 seconds to run on a P4
;
; 
    include \masm32\include\masm32rt.inc
; 

    Find_Key_Node    PROTO :DWORD, :DWORD
    Create_Nodes     PROTO
    Node_File_Create PROTO
    Node_File_Open   PROTO
    Node_File_Close  PROTO
    Node_File_Pos    PROTO :DWORD
    Node_File_Write  PROTO :DWORD
    Node_File_Read   PROTO :DWORD
    Clear_Node       PROTO :DWORD, :DWORD
    Add_Node_Key     PROTO :DWORD, :DWORD
    Create_Combos    PROTO

    Node_Item STRUCT
        TheKey   DWORD ?
        Lt_Ptr   DWORD ?
        Eq_Ptr   DWORD ?
        Rt_Ptr   DWORD ?
    Node_Item ENDS

.data

    Node_File          db "PB_Nodes.dat", 0
    Node_Order         dd 48
    Node_Level         dd 4
    Node_Size          dd 756
    Node_Recs_Need     dd 5006386
    Node_RootBuffer    dd 756 dup(0)
    Node_WorkBuffer    dd 756 dup(0)
    Node1              db 756 dup(0) ; Level one record
    Node2              db 756 dup(0) ; Level two record
    Node3              db 756 dup(0) ; Level three record
    Node4              db 756 dup(0) ; Level four record
    Node5              db 756 dup(0) ; Level five record
    N_hFile            dd 0
    N_FileSize         dd 0
    N_FilePtr          dd 0
    N_bRead            dd 0
    N_bWrite           dd 0
    N_bSeek            dd 0
    N_RecSize          dd 0
    N0Cnt              dd 0          ; how many keys in current node file
    N1Cnt              dd 0          ; how many keys in current node Level 1
    N2Cnt              dd 0          ; how many keys in current node Level 2
    N3Cnt              dd 0          ; how many keys in current node Level 3
    N4Cnt              dd 0          ; how many keys in current node Level 4
    N5Cnt              dd 0          ; how many keys in current node Level 5
    N0Ptr              dd 0          ; master ptr
    N1Ptr              dd 0          ; key ptr for node Level 1
    N2Ptr              dd 0          ; key ptr for node Level 2
    N3Ptr              dd 0          ; key ptr for node Level 3
    N4Ptr              dd 0          ; key ptr for node Level 4
    N5Ptr              dd 0          ; key ptr for node Level 5
    N1Full             dd 0          ; Flag for node Level 1 is full, save record and reinitialize, reset flag
    N2Full             dd 0          ; Flag for node Level 2 is full, save record and reinitialize, reset flag
    N3Full             dd 0          ; Flag for node Level 3 is full, save record and reinitialize, reset flag
    N4Full             dd 0          ; Flag for node Level 4 is full, save record and reinitialize, reset flag
    N5Full             dd 0          ; Flag for node Level 5 is full, save record and reinitialize, reset flag
    Comp_C1            dd 0          ; temp holder
    Comp_C2            dd 0          ; temp holder
    Comp_C3            dd 0          ; temp holder
    Comp_C4            dd 0          ; temp holder
    Comp_C5            dd 0          ; temp holder
    Temp1              dd 0          ; temp holder
    Temp2              dd 0          ; temp holder

; 
; To create PB_Nodes.dat
;
;          invoke Create_Nodes
;
;  Note: the procedure uses a secondary file combo.dat to seed each key
;        after all keys have been processed then you do not need combo.dat
;
;        to create combo.dat
;            invoke Create_Combos
;
; 
; To find a key_node = the one with the correct combination sequence in it
;
;     invoke Find_Key_Node, Temp1, ADDR Temp2
;
;           Temp1 is the Key_value and Temp2 is used to hold the record ptr
;
;           On return if Temp2 equals zero then key was not in table else record ptr
;
; 
.code
start:
    ; --------------------------
    print "Creating Combos.dat", 13, 10
    print "     Records   =  5,006,386", 13, 10
    print "     File size = 80,102,176", 13, 10, 13, 10
    print "Creating C.ndx", 13, 10
    print "     Records   =  5,006,386", 13, 10
    print "     File size = 40,051,088", 13, 10, 13, 10
    print "Please wait - processing", 13, 10, 13, 10
    invoke Create_Combos
    ; --------------------------
    print "Creating Node PB_Node.dat", 13, 10
    print "     File size = 81,978,372", 13, 10, 13, 10
    print "Please wait - processing", 13, 10, 13, 10
    invoke Create_Nodes
    ; --------------------------
    print "Find Combo 10, 23, 27, 41, 54", 13, 10
                xor eax, eax
                mov Temp2, eax
                mov eax, 10
                shl eax, 24
                mov Comp_C1, eax
                xor eax, eax
                mov eax, 23
                shl eax, 18
                mov Comp_C2, eax
                xor eax, eax
                mov eax, 27
                shl eax, 12
                mov Comp_C3, eax
                xor eax, eax
                mov eax, 41
                shl eax, 6
                mov Comp_C4, eax
                xor eax, eax
                mov eax, 54
                mov Comp_C5, eax
                or eax, Comp_C4
                or eax, Comp_C3
                or eax, Comp_C2
                or eax, Comp_C1
                mov Temp1, eax
                invoke Find_Key_Node, Temp1, ADDR Temp2
                mov eax, Temp2
                .if eax != 0
                    print "     Found Test Combo at record = "
                    print   str$(eax), 13, 10
                .else
                    print "     Test Comob Not Found", 13, 10
                .endif
    ; --------------------------
    print " ", 13, 10
    print "Note memory footprint is very small ~50K", 13,10
    print "     however, diskspace used is very large", 13, 10, 13, 10
    inkey "Press any key to exit..."
    ; --------------------------
    exit
;
; 
Find_Key_Node proc KeyValue :DWORD, KeyAddr :DWORD
    LOCAL KeyPtr      :DWORD
    LOCAL KeyNode     :DWORD
    LOCAL KeyFile     :DWORD
    LOCAL KeyFileSize :DWORD
    LOCAL KeyFileRecs :DWORD
    LOCAL bRead       :DWORD
    LOCAL bWrite      :DWORD
    LOCAL bSeek       :DWORD
    LOCAL KeyMaxSide  :DWORD

; -------------------
; Basic Node Structure is as follows
;
; Keys_In_Node_Count         :DWORD
; Key Value                  :DWORD
; Left Transverse Value      :DWORD   Non-Zero is a Node Record Pointer, Zero is a leaf
; Equal Transverse Value     :DWORD   Database Record Pointer
; Right Transverse Value     :DWORD   Non-Zero is a Node Record Pointer, Zero is a leaf
;
; Repeat (Key, Left, Equal, Right) for multiway keys
; -------------------
; Register useage
; 
; ESI    for the Node_Workbuffer pointer
; EBX    for the Internal_Node_Pointer
; ECX    for the Nodes current keyvalue
; EDX    for the search keyvalue
; EAX    for return value
; -------------------
    push esi
    push edi
    push eax
    push ebx
    push ecx
    push edx
; -------------------
    xor eax, eax
    mov KeyPtr, eax ; default to not found
; -------------------
    push eax
    push ecx
    push edx
    mov KeyFile, fopen(ADDR Node_File)
    pop edx
    pop ecx
    pop eax
; -------------------
    push edx
    push ecx
    mov bRead, fread(KeyFile,  ADDR Node_WorkBuffer, Node_Size) ; First rec is Root Node
    pop ecx
    pop edx
; -------------------
    mov edx, KeyValue
; -------------------
Quick_Test_Node:
; -------------------
    lea esi, Node_WorkBuffer
    add esi, 4                              ; Adjust for count field
    mov ecx, (Node_Item PTR [esi]).TheKey   ; get the most Leftside keyvalue of current node
    cmp ecx, edx                            ; Compare the Leftside keyvalue with Search KeyValue
    ja Get_New_Node_Left                    ; Jmp if so
    je Found_KeyValue                       ; Jmp if so
    lea esi, Node_WorkBuffer
    mov ebx, [esi]                          ; Number of keys in current Node
    dec ebx                                 ; Radix Adjustment
    shl ebx, 4                              ; Multiply by sixteen (Key, Left, Equal, and Right are all DD's)
    add ebx, 4                              ; Adjust for count field
    add ebx, esi
    mov esi, ebx                            ; set internal pointer
    mov ecx, (Node_Item PTR [esi]).TheKey   ; get the most Rightside keyvalue of current node
    cmp ecx, edx                            ; Compare the Rightside keyvalue with Search KeyValue
    jb Get_New_Node_Right                   ; Jmp if so
    je Found_KeyValue                       ; Jmp if so
    jmp Find_Key                            ; Go and Test current node for Search KeyValue    
; -------------------
Get_New_Node_Left:
; -------------------
    mov eax, (Node_Item PTR [esi]).Lt_Ptr   ; Get Left Transverse Pointer Value
    jmp Get_New_Node
; -------------------
Get_New_Node_Right:
; -------------------
    mov eax, (Node_Item PTR [esi]).Rt_Ptr   ; Get Right Transverse Pointer Value
; -------------------
Get_New_Node:
; -------------------
    .if eax == 0                            ; if ptr is zero then key is not in btree so exit
        jmp All_Done
    .endif
    push edx
    sub eax, 1                              ; Radix adjustment
    mul Node_Size                           ; Multiply by the Size of each Node
    pop edx
    ; -------------------
    push edx
    push ecx
    mov bSeek, fseek(KeyFile, eax, FILE_BEGIN)
    pop ecx
    pop edx
    ; -------------------
    push edx
    push ecx
    mov bRead, fread(KeyFile,  ADDR Node_WorkBuffer, Node_Size)
    pop ecx
    pop edx
    jmp Quick_Test_Node
; -------------------
Find_Key:
; -------------------
    lea esi, Node_WorkBuffer
    mov ebx, [esi]                          ; Key Count in current Node
    add esi, 4                              ; Adjust for count field
    mov edx, KeyValue                       ; Make sure we have the correct KeyValue to search for
; -------------------
Key_Test:
; -------------------
    mov ecx, (Node_Item PTR [esi]).TheKey
    cmp ecx, edx                            ; Compare nodes KeyValue with Search KeyValue
    je Found_KeyValue                       ; If they are equal then jump to found KeyValue
    jb Next_Key_Test                        ; If nodes KeyValue is less than Search KeyValue get next node KeyValue
    mov eax, (Node_Item PTR [esi]).Lt_Ptr   ; Get Left Transverse Pointer Value because nodes Keyvalue is greater than Search KeyValue
    jmp Get_New_Node                        ; Then get new node
Next_Key_Test:
    add esi, 16                             ; Add for structure of Node Item
    dec ebx                                 ; reduce count by 1
    jnz Key_Test                            ; if ebx greater than zero we still have more to check
    jmp All_Done                            ; We did not find the KeyValue so exit out
; -------------------
Found_KeyValue:
; -------------------
    mov eax, (Node_Item PTR [esi]).Eq_Ptr ; Get Equal Transverse Pointer Value
    mov KeyPtr, eax
; -------------------
All_Done:
; -------------------
    push eax
    push ecx
    push edx
    fclose KeyFile ; Close File
    pop edx
    pop ecx
    pop eax
; -------------------
    mov eax, KeyPtr    ; Value of KeyPtr if found else Zero
    mov ebx, KeyAddr   ; Address to store Value
    mov [ebx], eax     ; Store it
; -------------------
qexit:
    pop edx
    pop ecx
    pop ebx
    pop eax
    pop edi
    pop esi
    ret
Find_Key_Node endp
; 
Create_Nodes proc
    LOCAL hFile1      :DWORD
    LOCAL nSize1      :DWORD
    LOCAL nByte1      :DWORD
    LOCAL buffer[128] :BYTE
    LOCAL C1          :DWORD
    LOCAL C2          :DWORD
    LOCAL C3          :DWORD
    LOCAL C4          :DWORD
    LOCAL C5          :DWORD
    LOCAL C91         :DWORD
    LOCAL C92         :DWORD
    LOCAL C93         :DWORD
    LOCAL C94         :DWORD
    LOCAL C95         :DWORD
    LOCAL CntRec      :DWORD
    
    push esi
    push edi
    push eax
    push ebx
    push ecx
    push edx
    xor eax, eax
    mov C91, eax
    mov C92, eax
    mov C93, eax
    mov C94, eax
    mov C95, eax
    mov CntRec, eax    
    mov N0Cnt, eax
    mov N1Cnt, eax
    mov N2Cnt, eax
    mov N3Cnt, eax
    mov N4Cnt, eax
    mov N5Cnt, eax
    mov eax, 1
    mov N1Ptr, eax
    mov eax, 2
    mov N2Ptr, eax
    mov eax, 3
    mov N3Ptr, eax
    mov eax, 4
    mov N4Ptr, eax
    mov eax, 4
    mov N0Ptr, eax
    invoke Node_File_Create
    invoke Node_File_Open
    invoke Clear_Node, ADDR Node1, Sizeof Node1
    invoke Clear_Node, ADDR Node2, Sizeof Node2
    invoke Clear_Node, ADDR Node3, Sizeof Node3
    invoke Clear_Node, ADDR Node4, Sizeof Node4
; create loop to read Combos file and write KeyValues and Correct Pointers
;    invoke Save_Node, ADDR Node1, N1Ptr, N_RecSize
;    invoke Save_Node, ADDR Node2, N1Ptr, N_RecSize
;    invoke Save_Node, ADDR Node3, N1Ptr, N_RecSize
;    invoke Save_Node, ADDR Node4, N1Ptr, N_RecSize
    push eax
    push ecx
    push edx
    mov hFile1, fopen("Combos.dat")
    pop edx
    pop ecx
    pop eax
    mov eax, 16
    mov nSize1, eax
Read_Again:
    push edx
    push ecx
    mov nByte1, fread(hFile1, ADDR buffer, nSize1)
    pop ecx
    pop edx
    cmp nByte1, 0
    je exit_Read
    lea esi, buffer
    xor eax, eax              ; just to be safe
    mov al, [esi][0]          ; Read C1 byte
    mov C1, eax
    mov al, [esi][1]          ; Read C2 byte
    mov C2, eax
    mov al, [esi][2]          ; Read C3 byte
    mov C3, eax
    mov al, [esi][3]          ; Read C4 byte
    mov C4, eax
    mov al, [esi][4]          ; Read C5 byte
    mov C5, eax
    mov eax, C1
    shl eax, 24
    mov Comp_C1, eax
    mov eax, C2
    shl eax, 18
    mov Comp_C2, eax
    mov eax, C3
    shl eax, 12
    mov Comp_C3, eax
    mov eax, C4
    shl eax, 6
    mov Comp_C4, eax
    mov eax, C5
    mov Comp_C5, eax        
    or eax, Comp_C4
    or eax, Comp_C3
    or eax, Comp_C2
    or eax, Comp_C1
    ;
    ; eax has keyvalue to insert into PB_Node
    ;
    mov ebx, CntRec
    inc ebx
    mov CntRec, ebx
    invoke Add_Node_Key, eax, ebx
    jmp Read_Again
exit_Read:

    lea edi, Node1                      ; buffer location
    mov eax, N1Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N1Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node1  ; write data

    lea edi, Node2                      ; buffer location
    mov eax, N2Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N2Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node2  ; write data

    lea edi, Node3                      ; buffer location
    mov eax, N3Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N3Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node3  ; write data

    lea edi, Node4                      ; buffer location
    mov eax, N4Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N4Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node4  ; write data

    push eax
    push ecx
    push edx
    fclose hFile1   ; Close File
    pop edx
    pop ecx
    pop eax
    invoke Node_File_Close
qexit:
    pop edx
    pop ecx
    pop ebx
    pop eax
    pop edi
    pop esi
    ret
;
; Create development Screen
;    1) Determine Orderway size and/or select value
;    2) Determine height of Tree to use (max of five levels) - Balance this with number of records
;    3) Determine bushy size
;        a) orderway size less ((num of keys max less used keys) devided by number of nodes)
;    4) Save setting to system
;    5) For each Level (1-5) Display Keys and leafs for Min, Max, Qty of Nodes, and Total Size
;    6) Establish Error rountine for bounds and efficiency control
;
; Read live table and create indexed nodes
;    1) Use saved settings
;    2) Create Two nodes
;        a) Higher node
;        b) Lower node
;    2) Save bushy records in lower node
;        a) When bushy records has been saved
;           Create new lower node
;           Add one record to Higher node
;           Check to see if Higher node has bushy records in it
;               If so, create new higher level
;    3) When all records have been saved
;        a) Save record number of Higher Node as Root node
;        
; Search Mode
; Set Ptr to not found
;
; Reentry point
;
; If MinKey less than Key then goto Left transverse
; If MaxKey greater than Key then goto Right transverse
; If Key is in current node range, search it
; If Key found save Ptr and goto exit else goto exit
; Start at reentry point
;
; Left transverse
; get new node
; repeat process - recurse at reentry point
;
; Right transverse
; get new node
; repeat process - recurse at reentry point
;
; BTREE SEARCH x, k
; i <- 1
; while i <= n[x] and k > key(i)[x]
;    do i <- i + 1
;       if i <= n[x] and k = key(i)[x]
;          then return (x, i)
;       if leaf[x]
;          then return NIL
;       else Disk-Read(ci[x])
;           return B-Tree-Search(ci[x], k)       <==== recursive
; To be determined
;
Create_Nodes endp
; 
;BTREE_Evaluation proc
; Create this in a separate procedure that runs on its own. Console Mode also.
;
; Spreadsheet indicates that the multiway order should = 48
;             with a level height of 4 which puts it at a 98.23% capcity
;
; There will be 47 keys per node
;
;BTREE_Evaluation endp
; 
Node_File_Create proc
    push esi
    push edi
    push edx
    push ecx
    push ebx
    push eax
; -------------------
    push eax
    push ecx
    push edx
    mov N_hFile, fcreate(ADDR Node_File)
    pop edx
    pop ecx
    pop eax
; -------------------
    invoke Clear_Node, ADDR Node1, Sizeof Node1
    ; -------------------
    ;    Recs needed = INT((Node_Recs_Need / (Node_Order - 1)) + 1)
    ;    106520 = Int((5006386 / (48 - 1)) + 2)
    ;
    ;  Max for a 4 level 48 order is 108,437
    ; -------------------
    mov eax, 108437            ; Create this many records for the Node File
    mov ecx, eax               ; Set Counter
    xor eax, eax               ; Set Value
next_rec:
    ; -------------------
    invoke Node_File_Write, ADDR Node1
    dec ecx
    jnz next_rec
    ; -------------------
    invoke Node_File_Close
    ; -------------------
    pop eax
    pop ebx
    pop ecx
    pop edx
    pop edi
    pop esi
    ret
Node_File_Create endp
; 
Node_File_Open proc
    push esi
    push edi
    push edx
    push ecx
    push ebx
    push eax
    mov N_hFile, fopen(ADDR Node_File)
    pop eax
    pop ebx
    pop ecx
    pop edx
    pop edi
    pop esi
    ret
Node_File_Open endp
; 
Node_File_Close proc
    push esi
    push edi
    push edx
    push ecx
    push ebx
    push eax
    fclose N_hFile    ; Close File
    pop eax
    pop ebx
    pop ecx
    pop edx
    pop edi
    pop esi
    ret
Node_File_Close endp
; 
Node_File_Pos proc vRec :DWORD
    push esi
    push edi
    push edx
    push ecx
    push ebx
    push eax
    ; -------------------
    xor edx, edx       ; Clear out
    mov ecx, vRec      ; Key Pointer
    dec ecx            ; Radix adjustment
    mov eax, Node_Size ; Size of Nodes
    mul ecx
;    .if edx > 0
;        invoke DBBOX, ecx     ; display value
;    .endif    
    push edx
    push ecx
    mov N_bSeek, fseek(N_hFile, eax, FILE_BEGIN)
    pop ecx
    pop edx
    ; -------------------
    pop eax
    pop ebx
    pop ecx
    pop edx
    pop edi
    pop esi
    ret
Node_File_Pos endp
; 
Node_File_Write proc pNode :DWORD
    push edi
    push esi
    push edx
    push ecx
    push ebx
    push eax
    mov eax, Node_Size
    mov esi, pNode
    mov N_bWrite, fwrite(N_hFile, esi, eax)
    pop eax
    pop ebx
    pop ecx
    pop edx
    pop esi
    pop edi
    ret
Node_File_Write endp
; 
Node_File_Read proc pNode :DWORD
    push edi
    push esi
    push edx
    push ecx
    push ebx
    push eax
    mov N_bRead, fread(N_hFile, pNode, Node_Size)
    pop eax
    pop ebx
    pop ecx
    pop edx
    pop esi
    pop edi
    ret
Node_File_Read endp
; 
Clear_Node proc pNx :DWORD, vSize :DWORD
    push edi
    push ecx
    push eax
    mov edi, pNx     ; Pointer to buffer
    mov ecx, vSize   ; Quantity of bytes in buffer
    xor eax, eax     ; Clear value
next_byte:
    mov [edi], al    ; Save byte
    inc edi          ; Increment Pointer
    dec ecx          ; Decrement Quantity
    jnz next_byte    ; If we are not done jump next_byte
    pop eax          ; We are done
    pop ecx
    pop edi
    ret    
Clear_Node endp
; 
Add_Node_Key proc vKey :DWORD, pKey :DWORD
    LOCAL nHold :DWORD
    
    mov eax, N4Cnt                      ; Current Node 4 position
    mov ebx, Node_Order                 ; Max Children per node
    dec ebx                             ; radix adjustment
    cmp eax, ebx                        ; Test if Current Node is full
    je Parent3_Save                     ; Jump if it is
    lea edi, Node4                      ; buffer location
    mov eax, N4Cnt                      ; Current Node 4 position
    inc eax                             ; add 1
    mov N4Cnt, eax                      ; Save count
    dec eax                             ; Radix adjustment
    shl eax, 4                          ; multipy by 16
    add eax, 4                          ; account for count field
    add eax, edi                        ; created offset
    mov edi, eax                        ; point to it
    mov eax, vKey                       ; Save Key and Pointer
    mov (Node_Item Ptr [edi]).TheKey, eax
    mov eax, pKey
    mov (Node_Item PTR [edi]).Eq_Ptr, eax
    ret
Parent3_Save:
    mov eax, N4Ptr                      ; Get current node record pointer
    mov nHold, eax                      ; Temp Save Pointer
    lea edi, Node4                      ; buffer location
    mov eax, N4Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N4Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node4  ; write data
    mov eax, N0Ptr                      ; blank record pointer
    inc eax                             ; increment it
    mov N0Ptr, eax                      ; save it for next time
    mov N4Ptr, eax                      ; align with node
    xor eax, eax                        ; just geting ready
    mov N4Cnt, eax                      ; clear quantity
    invoke Node_File_Pos, N4Ptr         ; setup read position
    invoke Node_File_Read, ADDR Node4   ; read data - shortcut to clearing buffer
; --------------------------------------  ok node4 has been saved now proccess key in parrent level
    mov eax, N3Cnt                      ; Current Node 3 position
    mov ebx, Node_Order                 ; Max Children per node
    dec ebx                             ; radix adjustment
    cmp eax, ebx                        ; Test if Current Node is full
    je Parent2_Save                     ; Jump if it is
    lea edi, Node3                      ; buffer location
    mov eax, N3Cnt                      ; Current Node 3 position
    inc eax                             ; add 1
    mov N3Cnt, eax                      ; Save count
    dec eax                             ; Radix adjustment
    shl eax, 4                          ; multipy by 16
    add eax, 4                          ; account for count field
    add eax, edi                        ; created offset
    mov edi, eax                        ; point to it
    mov eax, vKey                       ; Save Key and Pointers
    mov (Node_Item Ptr [edi]).TheKey, eax
    mov eax, pKey
    mov (Node_Item PTR [edi]).Eq_Ptr, eax
    mov eax, nHold
    mov (Node_Item PTR [edi]).Lt_Ptr, eax
    mov eax, N4Ptr
    mov (Node_Item PTR [edi]).Rt_Ptr, eax
    ret
Parent2_Save:
    mov eax, N3Ptr                      ; Get current node record pointer
    mov nHold, eax                      ; Temp Save Pointer
    lea edi, Node3                      ; buffer location
    mov eax, N3Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N3Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node3  ; write data
    mov eax, N0Ptr                      ; blank record pointer
    inc eax                             ; increment it
    mov N0Ptr, eax                      ; save it for next time
    mov N3Ptr, eax                      ; align with node
    xor eax, eax                        ; just geting ready
    mov N3Cnt, eax                      ; clear quantity
    invoke Node_File_Pos, N3Ptr         ; setup read position
    invoke Node_File_Read, ADDR Node3   ; read data - shortcut to clearing buffer
; --------------------------------------  ok node3 has been saved now proccess key in parrent level
    mov eax, N2Cnt                      ; Current Node 2 position
    mov ebx, Node_Order                 ; Max Children per node
    dec ebx                             ; radix adjustment
    cmp eax, ebx                        ; Test if Current Node is full
    je Parent1_Save                     ; Jump if it is
    lea edi, Node2                      ; buffer location
    mov eax, N2Cnt                      ; Current Node 2 position
    inc eax                             ; add 1
    mov N2Cnt, eax                      ; Save count
    dec eax                             ; Radix adjustment
    shl eax, 4                          ; multipy by 16
    add eax, 4                          ; account for count field
    add eax, edi                        ; created offset
    mov edi, eax                        ; point to it
    mov eax, vKey                       ; Save Key and Pointers
    mov (Node_Item Ptr [edi]).TheKey, eax
    mov eax, pKey
    mov (Node_Item PTR [edi]).Eq_Ptr, eax
    mov eax, nHold
    mov (Node_Item PTR [edi]).Lt_Ptr, eax
    mov eax, N3Ptr
    mov (Node_Item PTR [edi]).Rt_Ptr, eax
    ret
Parent1_Save:
    mov eax, N2Ptr                      ; Get current node record pointer
    mov nHold, eax                      ; Temp Save Pointer
    lea edi, Node2                      ; buffer location
    mov eax, N2Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    invoke Node_File_Pos, N2Ptr         ; setup write position
    invoke Node_File_Write, ADDR Node2  ; write data
    mov eax, N0Ptr                      ; blank record pointer
    inc eax                             ; increment it
    mov N0Ptr, eax                      ; save it for next time
    mov N2Ptr, eax                      ; align with node
    xor eax, eax                        ; just geting ready
    mov N2Cnt, eax                      ; clear quantity
    invoke Node_File_Pos, N2Ptr         ; setup read position
    invoke Node_File_Read, ADDR Node2   ; read data - shortcut to clearing buffer
; --------------------------------------  ok node3 has been saved now proccess key in parrent level
    lea edi, Node1                      ; buffer location
    mov eax, N1Cnt                      ; Current Node 1 position
    inc eax                             ; add 1
    mov N1Cnt, eax                      ; Save count
    dec eax                             ; Radix adjustment
    shl eax, 4                          ; multipy by 16
    add eax, 4                          ; account for count field
    add eax, edi                        ; created offset
    mov edi, eax                        ; point to it
    mov eax, vKey                       ; Save Key and Pointers
    mov (Node_Item Ptr [edi]).TheKey, eax
    mov eax, pKey
    mov (Node_Item PTR [edi]).Eq_Ptr, eax
    mov eax, nHold
    mov (Node_Item PTR [edi]).Lt_Ptr, eax
    mov eax, N2Ptr
    mov (Node_Item PTR [edi]).Rt_Ptr, eax
    lea edi, Node1                      ; buffer location
    mov eax, N1Cnt                      ; quantity in node
    mov [edi], eax                      ; save qty
    ret
Add_Node_Key endp
; 
Create_Combos proc
;
; Combo Logic
;
; For aa =  1 to 55
; For bb =  2 to 56
; For cc =  3 to 57
; For dd =  4 to 58
; For ee =  5 to 59
;     if aa < bb and bb < cc and cc < dd and dd < ee then
;        good
;        save record
;     else
;        bad - ignore and continue on
;     endif
; Next ee
; Next dd
; Next cc
; Next bb
; Next aa
;
; Note that there can be out of bounds if we use n + 1 for each col
; Therefore we use the good bad logic at the expense of execution speed
;
    LOCAL hFile       :DWORD
    LOCAL flen        :DWORD
    LOCAL frec        :DWORD
    LOCAL buffer[128] :BYTE
    LOCAL bRead       :DWORD
    LOCAL bWrite      :DWORD
    LOCAL C1          :DWORD
    LOCAL C2          :DWORD
    LOCAL C3          :DWORD
    LOCAL C4          :DWORD
    LOCAL C5          :DWORD
    LOCAL C1Start     :DWORD
    LOCAL C2Start     :DWORD
    LOCAL C3Start     :DWORD
    LOCAL C4Start     :DWORD
    LOCAL C5Start     :DWORD
    LOCAL C1Stop      :DWORD
    LOCAL C2Stop      :DWORD
    LOCAL C3Stop      :DWORD
    LOCAL C4Stop      :DWORD
    LOCAL C5Stop      :DWORD
    LOCAL nRecs       :DWORD
    LOCAL hFile2       :DWORD
    LOCAL flen2        :DWORD
    LOCAL frec2        :DWORD
    LOCAL buffer2[128] :BYTE
    LOCAL bRead2       :DWORD
    LOCAL bWrite2      :DWORD
    push esi
    push edi
    push eax
    push ebx
    push ecx
    push edx
; -------------------
    push eax
    push ecx
    push edx
         mov hFile, fcreate("Combos.dat")
    pop edx
    pop ecx
    pop eax
; -------------------
    push eax
    push ecx
    push edx
         mov hFile2, fcreate("C.ndx")
    pop edx
    pop ecx
    pop eax
; -------------------
    xor eax, eax
    lea esi, buffer
    mov [esi], eax        ; Zero first four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
    add esi, 4
    mov [esi], eax        ; Zero next four bytes
; -------------------
    mov nRecs,    0
    mov C1Start,  1
    mov C2Start,  2
    mov C3Start,  3
    mov C4Start,  4
    mov C5Start,  5

    mov C1Stop,  55
    mov C2Stop,  56
    mov C3Stop,  57
    mov C4Stop,  58
    mov C5Stop,  59
    lea esi, buffer
BeginC1:
    m2m C1, C1Start
    dec C1
LoopC1:
   m2m C2, C2Start
   dec C2
   inc C1
   mov eax, C1
   mov ebx, C1Stop
   cmp eax, ebx
   ja C1Done
LoopC2:
   m2m C3, C3Start
   dec C3
   inc C2
   mov eax, C2
   mov ebx, C2Stop
   cmp eax, ebx
   ja C2Done
LoopC3:
   m2m C4, C4Start
   dec C4
   inc C3
   mov eax, C3
   mov ebx, C3Stop
   cmp eax, ebx
   ja C3Done
LoopC4:
   m2m C5, C5Start
   dec C5
   inc C4
   mov eax, C4
   mov ebx, C4Stop
   cmp eax, ebx
   ja C4Done
LoopC5:
   inc C5
   mov eax, C5
   mov ebx, C5Stop
   cmp eax, ebx
   ja C5Done
; ---------------------- Determine if we have a good set of combos
   mov eax, C1
   mov ebx, C2
   cmp eax, ebx
   jnb LoopC5      ; Bad
   mov eax, C2
   mov ebx, C3
   cmp eax, ebx
   jnb LoopC5      ; Bad
   mov eax, C3
   mov ebx, C4
   cmp eax, ebx
   jnb LoopC5      ; Bad
   mov eax, C4
   mov ebx, C5
   cmp eax, ebx
   jnb LoopC5      ; Bad
   ; ------------------------- We have a good set of combos so process it
        lea esi, buffer
        xor eax, eax
        mov eax, C1
        mov [esi][0], al      ; Save C1 byte
        mov eax, C2
        mov [esi][1], al      ; Save C2 byte
        mov eax, C3
        mov [esi][2], al      ; Save C3 byte
        mov eax, C4
        mov [esi][3], al      ; Save C4 byte
        mov eax, C5
        mov [esi][4], al      ; Save C5 byte
        ;
        ; --------------------- Bytes 6, 7, 8 automatically set to Zero
        ;
        ; --------------------------------------------------- Save Record to Combos.ddat
        mov eax, 16            ; Record size
        mov bWrite, fwrite(hFile, esi, eax)
        ; ---------------------------------------------------
        inc nRecs
        mov eax, C1
        shl eax, 24
        mov Comp_C1, eax
        mov eax, C2
        shl eax, 18
        mov Comp_C2, eax
        mov eax, C3
        shl eax, 12
        mov Comp_C3, eax
        mov eax, C4
        shl eax, 6
        mov Comp_C4, eax
        mov eax, C5
        mov Comp_C5, eax        
        or eax, Comp_C4
        or eax, Comp_C3
        or eax, Comp_C2
        or eax, Comp_C1
        lea esi, buffer2
        mov [esi], eax
        add esi, 4
        mov eax, nRecs
        mov [esi], eax
        lea esi, buffer2
        mov eax, 8
        mov bWrite2, fwrite(hFile2, esi, eax)      ; Save Index value in Combos.ndx
   ; ------------------------- Process complete
   jmp LoopC5
C5Done:
    jmp LoopC4
C4Done:
    jmp LoopC3
C3Done:
    jmp LoopC2
C2Done:
    jmp LoopC1
C1Done:
; -------------------
    push eax
    push ecx
    push edx
         fclose hFile2
    pop edx
    pop ecx
    pop eax
; -------------------
    push eax
    push ecx
    push edx
         fclose hFile
    pop edx
    pop ecx
    pop eax
; -------------------
    pop edx
    pop ecx
    pop ebx
    pop eax
    pop edi
    pop esi
    mov eax, nRecs
    ; --------------------- nRecs = 3,960,887 vs C(59, 5) = 5,006,386  (File size = 31,687,096 Bytes vs File size = 80,102,176)
    ret
Create_Combos endp
; 
end start
